<template>
  <div>
    <h2 id="page-heading" data-cy="HistorialActividadHeading">
      <span v-text="$t('gatewayApp.biologicoHistorialActividad.home.title')" id="historial-actividad-heading">Historial Actividads</span>
      <div class="d-flex justify-content-end">
        <button class="btn btn-info mr-2" v-on:click="handleSyncList" :disabled="isFetching">
          <font-awesome-icon icon="sync" :spin="isFetching"></font-awesome-icon>
          <span v-text="$t('gatewayApp.biologicoHistorialActividad.home.refreshListLabel')">Refresh List</span>
        </button>
        <router-link :to="{ name: 'HistorialActividadCreate' }" custom v-slot="{ navigate }">
          <button
            @click="navigate"
            id="jh-create-entity"
            data-cy="entityCreateButton"
            class="btn btn-primary jh-create-entity create-historial-actividad"
          >
            <font-awesome-icon icon="plus"></font-awesome-icon>
            <span v-text="$t('gatewayApp.biologicoHistorialActividad.home.createLabel')"> Create a new Historial Actividad </span>
          </button>
        </router-link>
      </div>
    </h2>
    <br />
    <div class="alert alert-warning" v-if="!isFetching && historialActividads && historialActividads.length === 0">
      <span v-text="$t('gatewayApp.biologicoHistorialActividad.home.notFound')">No historialActividads found</span>
    </div>
    <div class="table-responsive" v-if="historialActividads && historialActividads.length > 0">
      <table class="table table-striped" aria-describedby="historialActividads">
        <thead>
          <tr>
            <th scope="row" v-on:click="changeOrder('id')">
              <span v-text="$t('global.field.id')">ID</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'id'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('fechaHistorial')">
              <span v-text="$t('gatewayApp.biologicoHistorialActividad.fechaHistorial')">Fecha Historial</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'fechaHistorial'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('cicloActividad.id')">
              <span v-text="$t('gatewayApp.biologicoHistorialActividad.cicloActividad')">Ciclo Actividad</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'cicloActividad.id'"></jhi-sort-indicator>
            </th>
            <th scope="row"></th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="historialActividad in historialActividads" :key="historialActividad.id" data-cy="entityTable">
            <td>
              <router-link :to="{ name: 'HistorialActividadView', params: { historialActividadId: historialActividad.id } }">{{
                historialActividad.id
              }}</router-link>
            </td>
            <td>{{ historialActividad.fechaHistorial ? $d(Date.parse(historialActividad.fechaHistorial), 'short') : '' }}</td>
            <td>
              <div v-if="historialActividad.cicloActividad">
                <router-link :to="{ name: 'CicloActividadView', params: { cicloActividadId: historialActividad.cicloActividad.id } }">{{
                  historialActividad.cicloActividad.id
                }}</router-link>
              </div>
            </td>
            <td class="text-right">
              <div class="btn-group">
                <router-link
                  :to="{ name: 'HistorialActividadView', params: { historialActividadId: historialActividad.id } }"
                  custom
                  v-slot="{ navigate }"
                >
                  <button @click="navigate" class="btn btn-info btn-sm details" data-cy="entityDetailsButton">
                    <font-awesome-icon icon="eye"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.view')">View</span>
                  </button>
                </router-link>
                <router-link
                  :to="{ name: 'HistorialActividadEdit', params: { historialActividadId: historialActividad.id } }"
                  custom
                  v-slot="{ navigate }"
                >
                  <button @click="navigate" class="btn btn-primary btn-sm edit" data-cy="entityEditButton">
                    <font-awesome-icon icon="pencil-alt"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.edit')">Edit</span>
                  </button>
                </router-link>
                <b-button
                  v-on:click="prepareRemove(historialActividad)"
                  variant="danger"
                  class="btn btn-sm"
                  data-cy="entityDeleteButton"
                  v-b-modal.removeEntity
                >
                  <font-awesome-icon icon="times"></font-awesome-icon>
                  <span class="d-none d-md-inline" v-text="$t('entity.action.delete')">Delete</span>
                </b-button>
              </div>
            </td>
          </tr>
        </tbody>
        <infinite-loading
          ref="infiniteLoading"
          v-if="totalItems > itemsPerPage"
          :identifier="infiniteId"
          slot="append"
          @infinite="loadMore"
          force-use-infinite-wrapper=".el-table__body-wrapper"
          :distance="20"
        >
        </infinite-loading>
      </table>
    </div>
    <b-modal ref="removeEntity" id="removeEntity">
      <span slot="modal-title"
        ><span
          id="gatewayApp.biologicoHistorialActividad.delete.question"
          data-cy="historialActividadDeleteDialogHeading"
          v-text="$t('entity.delete.title')"
          >Confirm delete operation</span
        ></span
      >
      <div class="modal-body">
        <p
          id="jhi-delete-historialActividad-heading"
          v-text="$t('gatewayApp.biologicoHistorialActividad.delete.question', { id: removeId })"
        >
          Are you sure you want to delete this Historial Actividad?
        </p>
      </div>
      <div slot="modal-footer">
        <button type="button" class="btn btn-secondary" v-text="$t('entity.action.cancel')" v-on:click="closeDialog()">Cancel</button>
        <button
          type="button"
          class="btn btn-primary"
          id="jhi-confirm-delete-historialActividad"
          data-cy="entityConfirmDeleteButton"
          v-text="$t('entity.action.delete')"
          v-on:click="removeHistorialActividad()"
        >
          Delete
        </button>
      </div>
    </b-modal>
  </div>
</template>

<script lang="ts" src="./historial-actividad.component.ts"></script>
